// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"strconv"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/swag"
)

// EventDetailsResult EventDetailsResult - Return Event details with respective ticket types
// swagger:model EventDetailsResult
type EventDetailsResult struct {

	// ticket types
	TicketTypes []*TicketType `json:"ticket_types"`

	// event
	Event *Event `json:"event,omitempty"`
}

// Validate validates this event details result
func (m *EventDetailsResult) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateTicketTypes(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateEvent(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *EventDetailsResult) validateTicketTypes(formats strfmt.Registry) error {

	if swag.IsZero(m.TicketTypes) { // not required
		return nil
	}

	for i := 0; i < len(m.TicketTypes); i++ {
		if swag.IsZero(m.TicketTypes[i]) { // not required
			continue
		}

		if m.TicketTypes[i] != nil {
			if err := m.TicketTypes[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("ticket_types" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *EventDetailsResult) validateEvent(formats strfmt.Registry) error {

	if swag.IsZero(m.Event) { // not required
		return nil
	}

	if m.Event != nil {
		if err := m.Event.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("event")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *EventDetailsResult) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *EventDetailsResult) UnmarshalBinary(b []byte) error {
	var res EventDetailsResult
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
